﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace TechNote51_SmartIO123_CS
{
    public partial class Form2 : Form
    {
        public Form2()
        {
            InitializeComponent();
        }

        private void btnSet_Click(object sender, EventArgs e)
        {
            GPIO_PortA.PortSelect = SmartX.SmartGPIO.PORTID.PORTA;
            GPIO_PortB.PortSelect = SmartX.SmartGPIO.PORTID.PORTB;

            // **중요** InputCounter 블럭보다 반드시 먼저 설정해 주어야함
            // A1이 Output인 경우
            if (chkPortA1.Checked == true)
            {
                // PORT A1을 출력으로 설정
                GPIO_PortA.DirPin0 = SmartX.SmartGPIO.PINDIR.OUTPUT;
                GPIO_PortA.DirPin1 = SmartX.SmartGPIO.PINDIR.OUTPUT;
                GPIO_PortA.DirPin2 = SmartX.SmartGPIO.PINDIR.OUTPUT;
                GPIO_PortA.DirPin3 = SmartX.SmartGPIO.PINDIR.OUTPUT;
            }

            // A2이 Output인 경우
            if (chkPortA2.Checked == false)
            {
                // PORT A2을 출력으로 설정
                GPIO_PortA.DirPin4 = SmartX.SmartGPIO.PINDIR.OUTPUT;
                GPIO_PortA.DirPin5 = SmartX.SmartGPIO.PINDIR.OUTPUT;
                GPIO_PortA.DirPin6 = SmartX.SmartGPIO.PINDIR.OUTPUT;
                GPIO_PortA.DirPin7 = SmartX.SmartGPIO.PINDIR.OUTPUT;
            }

            // B1이 Output인 경우
            if (chkPortB1.Checked == false)
            {
                // PORT A2을 출력으로 설정
                GPIO_PortB.DirPin0 = SmartX.SmartGPIO.PINDIR.OUTPUT;
                GPIO_PortB.DirPin1 = SmartX.SmartGPIO.PINDIR.OUTPUT;
                GPIO_PortB.DirPin2 = SmartX.SmartGPIO.PINDIR.OUTPUT;
                GPIO_PortB.DirPin3 = SmartX.SmartGPIO.PINDIR.OUTPUT;
            }

            // B2이 Output인 경우
            if (chkPortB2.Checked == false)
            {
                // PORT B2을 출력으로 설정
                GPIO_PortB.DirPin4 = SmartX.SmartGPIO.PINDIR.OUTPUT;
                GPIO_PortB.DirPin5 = SmartX.SmartGPIO.PINDIR.OUTPUT;
                GPIO_PortB.DirPin6 = SmartX.SmartGPIO.PINDIR.OUTPUT;
                GPIO_PortB.DirPin7 = SmartX.SmartGPIO.PINDIR.OUTPUT;
            }

            // A1을 InputCounter로 사용
            if (chkPortA1.Checked == true)
            {
                smartInputCounter1.InputCounterA1.PortMode = SmartX.SmartInputCounter.PORTMODES.Used;
                if (smartInputCounter1.InputCounterA1.Initialize() == true)
                {
                    // 32Bit의 경우 최대 4,294,967,295를 표현 가능하며 64Bit의 경우 최대 1.8E308까지 표현 가능합니다.
                    smartInputCounter1.InputCounterA1.CounterDataWidth = SmartX.SmartInputCounter.DATAWIDTH._32BIT;
                }
            }
            // A1을 InputCounter로 사용안함
            else
            {
                smartInputCounter1.InputCounterA1.PortMode = SmartX.SmartInputCounter.PORTMODES.NotUsed;
                btnPortA1_Start.Enabled = false;
                btnPortA1_Stop.Enabled = false;
            }

            // A2을 InputCounter로 사용
            if (chkPortA2.Checked == true)
            {
                smartInputCounter1.InputCounterA2.PortMode = SmartX.SmartInputCounter.PORTMODES.Used;
                if (smartInputCounter1.InputCounterA2.Initialize() == true)
                {
                    // 32Bit의 경우 최대 4,294,967,295를 표현 가능하며 64Bit의 경우 최대 1.8E308까지 표현 가능합니다.
                    smartInputCounter1.InputCounterA2.CounterDataWidth = SmartX.SmartInputCounter.DATAWIDTH._32BIT;
                }
            }
            // A2을 InputCounter로 사용안함
            else
            {
                smartInputCounter1.InputCounterA2.PortMode = SmartX.SmartInputCounter.PORTMODES.NotUsed;
                btnPortA2_Start.Enabled = false;
                btnPortA2_Stop.Enabled = false;
            }

            // B1을 InputCounter로 사용
            if (chkPortB1.Checked == true)
            {
                smartInputCounter1.InputCounterB1.PortMode = SmartX.SmartInputCounter.PORTMODES.Used;
                if (smartInputCounter1.InputCounterB1.Initialize() == true)
                {
                    // 32Bit의 경우 최대 4,294,967,295를 표현 가능하며 64Bit의 경우 최대 1.8E308까지 표현 가능합니다.
                    smartInputCounter1.InputCounterB1.CounterDataWidth = SmartX.SmartInputCounter.DATAWIDTH._32BIT;
                }
            }
            // B1을 InputCounter로 사용안함
            else
            {
                smartInputCounter1.InputCounterB1.PortMode = SmartX.SmartInputCounter.PORTMODES.NotUsed;
                btnPortB1_Start.Enabled = false;
                btnPortB1_Stop.Enabled = false;
            }

            // B2을 InputCounter로 사용
            if (chkPortB2.Checked == true)
            {
                smartInputCounter1.InputCounterB2.PortMode = SmartX.SmartInputCounter.PORTMODES.Used;
                if (smartInputCounter1.InputCounterB2.Initialize() == true)
                {
                    // 32Bit의 경우 최대 4,294,967,295를 표현 가능하며 64Bit의 경우 최대 1.8E308까지 표현 가능합니다.
                    smartInputCounter1.InputCounterB2.CounterDataWidth = SmartX.SmartInputCounter.DATAWIDTH._32BIT;
                }
            }
            // B2을 InputCounter로 사용안함
            else
            {
                smartInputCounter1.InputCounterB2.PortMode = SmartX.SmartInputCounter.PORTMODES.NotUsed;
                btnPortB2_Start.Enabled = false;
                btnPortB2_Stop.Enabled = false;
            }

            // SmartTimer는 Input Counter의 Count 값, Status 값, Output의 On/Off 출력
            if (smartTimer1.IsStart == false)
            {
                smartTimer1.Interval = 10;
                smartTimer1.Start();
            }
        }

        // A1 PIN1 Start/Stop
        private void btnPortA1Button_Click(object sender, EventArgs e)
        {
            if (chkPortA1.Checked == true)
            {
                if (sender == btnPortA1_Start)
                {
                    smartInputCounter1.InputCounterA1.RunCounterPin1();
                }
                else
                {
                    smartInputCounter1.InputCounterA1.PauseCounterPin1();
                }
            }
        }

        // A2 PIN1 Start/Stop
        private void btnPortA2Button_Click(object sender, EventArgs e)
        {
            if (chkPortA2.Checked == true)
            {
                if (sender == btnPortA2_Start)
                {
                    smartInputCounter1.InputCounterA2.RunCounterPin1();
                }
                else
                {
                    smartInputCounter1.InputCounterA2.PauseCounterPin1();
                }
            }
        }

        // B1 PIN1 Start/Stop
        private void btnPortB1Button_Click(object sender, EventArgs e)
        {
            if (chkPortB1.Checked == true)
            {
                if (sender == btnPortB1_Start)
                {
                    smartInputCounter1.InputCounterB1.RunCounterPin1();
                }
                else
                {
                    smartInputCounter1.InputCounterB1.PauseCounterPin1();
                }
            }
        }

        // B2 PIN1 Start/Stop
        private void btnPortB2Button_Click(object sender, EventArgs e)
        {
            if (chkPortB2.Checked == true)
            {
                if (sender == btnPortB2_Start)
                {
                    smartInputCounter1.InputCounterB2.RunCounterPin1();
                }
                else
                {
                    smartInputCounter1.InputCounterB2.PauseCounterPin1();
                }
            }
        }

        // Input Counter의 Count 값, Status 값, Output의 On/Off 출력
        private void smartTimer1_Tick(object sender, EventArgs e)
        {
            // A1의 PIN1 InputCounter 처리
            try
            {
                if (chkPortA1.Checked == true)
                {
                    labPortA1.Text = smartInputCounter1.InputCounterA1.CounterPin1.ToString();
                }
            }
            catch (SmartX.SmartInputCounter.CheckSumErrorException)
            {
                labPortA1.Text = "Data Error";
                labPortA1.Text = "0";
            }

            // A2의 PIN1 InputCounter 처리
            try
            {
                if (chkPortA2.Checked == true)
                {
                    labPortA2.Text = smartInputCounter1.InputCounterA2.CounterPin1.ToString();
                }
            }
            catch (SmartX.SmartInputCounter.CheckSumErrorException)
            {
                labPortA2.Text = "Data Error";
                labPortA2.Text = "0";
            }

            // B1의 PIN1 InputCounter 처리
            try
            {
                if (chkPortB1.Checked == true)
                {
                    labPortB1.Text = smartInputCounter1.InputCounterB1.CounterPin1.ToString();
                }
            }
            catch (SmartX.SmartInputCounter.CheckSumErrorException)
            {
                labPortB1.Text = "Data Error";
                labPortB1.Text = "0";
            }

            // B2의 PIN1 InputCounter 처리
            try
            {
                if (chkPortB2.Checked == true)
                {
                    labPortB2.Text = smartInputCounter1.InputCounterB2.CounterPin1.ToString();
                }
            }
            catch (SmartX.SmartInputCounter.CheckSumErrorException)
            {
                labPortB2.Text = "Data Error";
                labPortB2.Text = "0";
            }
        }

        // Show Form1 버튼
        private void btnShowForm1_Click(object sender, EventArgs e)
        {
            // SmartInputCounter Pause
            smartInputCounter1.InputCounterA1.PauseCounterPin1();
            smartInputCounter1.InputCounterA2.PauseCounterPin1();
            smartInputCounter1.InputCounterB1.PauseCounterPin1();
            smartInputCounter1.InputCounterB2.PauseCounterPin1();

            // CheckBox 초기화
            chkPortA1.Checked = false;
            chkPortA2.Checked = false;
            chkPortB1.Checked = false;
            chkPortB2.Checked = false;

            smartForm1.Show(0);
        }
    }
}