﻿Public Class Form1

    Private m_iPwm1Duty As Integer
    Private m_iPwm2Duty As Integer

    Private m_iDACChannel As Integer = 0
    Public m_bPreB6Status As Boolean
    Public m_bPreB7Status As Boolean
    Private m_iPWMChannel As Integer

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Load
        Dim frm2 As Form2 = New Form2()

        ' 현재 Form을 MainForm으로 설정합니다.
        SmartForm1.MainForm = Me
        ' MainForm에 Child Form을 추가합니다.
        SmartForm1.AddChildForm(frm2)
        SmartForm1.ChildFormLocation(105, 54)

        ' 초기 PWM1, 2의 Duty 값 설정 및 표시
        SmartPWM1.SetCarryFrequency1(SmartX.SmartPWM.CLOCKDIVIDER.DIVIDE2, 33, 500)
        SmartPWM1.DutyRate1 = 50
        SmartPWM1.SetCarryFrequency2(SmartX.SmartPWM.CLOCKDIVIDER.DIVIDE2, 33, 500)
        SmartPWM1.DutyRate2 = 50

        m_iPwm1Duty = 50
        m_iPwm2Duty = 50

        ' SmartUpDown의 Button을 누르고 있을 때 가속 모드로 점점 빨라지도록 설정
        udPWM.SpecialFunction = SmartX.SmartButton.SPECIALFUNC.REPT
        ' 가속을 위한 RepeatAccelerate 설정
        Dim repAcc As SmartX.SmartButton.RepeatAccelerate() = New SmartX.SmartButton.RepeatAccelerate(2) {}

        ' 처음 Button의 클릭횟수 10회 동안은 Interval이 300ms
        repAcc(0).iClickCount = 10
        repAcc(0).iInterval = 300

        ' 그다음 Button의 클릭횟수 10회 동안은 Interval이 100ms
        repAcc(1).iClickCount = 10
        repAcc(1).iInterval = 100

        ' 그다음 Button의 클릭횟수 10회 동안은 Interval이 10ms
        repAcc(2).iClickCount = 10
        repAcc(2).iInterval = 10

        udPWM.RepeatIntervalAccelerate = repAcc
        udDAC.RepeatIntervalAccelerate = repAcc

        ' SmartGPIO Port Select
        GPIO_PortA.PortSelect = SmartX.SmartGPIO.PORTID.PORTA
        GPIO_PortB.PortSelect = SmartX.SmartGPIO.PORTID.PORTB
        GPIO_PortC.PortSelect = SmartX.SmartGPIO.PORTID.PORTC
        GPIO_PortD.PortSelect = SmartX.SmartGPIO.PORTID.PORTD
        GPIO_PortE.PortSelect = SmartX.SmartGPIO.PORTID.PORTE
        GPIO_PortF.PortSelect = SmartX.SmartGPIO.PORTID.PORTF

        SmartForm1.Show(0)
    End Sub

    ' Start 버튼 클릭
    Private Sub btnStart_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnStart.Click
        ' SmartGPIO
        ' SmartGPIO 입력 신호 감지 시작
        GPIO_PortA.PortWatchStart()
        GPIO_PortB.PortWatchStart()
        GPIO_PortC.PortWatchStart()
        GPIO_PortD.PortWatchStart()
        GPIO_PortE.PortWatchStart()
        GPIO_PortF.PortWatchStart()

        ' SmartADC
        ' ADC값을 읽어오는 Timer를 시작
        SmartTimer1.Start()

        ' SmartDAC
        ' SmartDAC를 사용하기 전 PortB6,7이 Input이었다면 이전상태 저장
        If btnPortDirB6.ButtonStatus = SmartX.SmartButton.BUTSTATUS.UP Then
            m_bPreB6Status = True
        End If
        If btnPortDirB7.ButtonStatus = SmartX.SmartButton.BUTSTATUS.UP Then
            m_bPreB7Status = True
        End If

        If radDAC1.Checked = True Then
            m_iDACChannel = 1
        ElseIf radDAC2.Checked = True Then
            m_iDACChannel = 2
        End If

        If m_iDACChannel <> 0 Then
            ' DAC를 사용하기 위해 Port B6, B7 방향을 OUTPUT으로 설정
            GPIO_PortB.DirPin6 = SmartX.SmartGPIO.PINDIR.OUTPUT
            GPIO_PortB.DirPin7 = SmartX.SmartGPIO.PINDIR.OUTPUT
            btnPortDirB6.ButtonDown()
            btnPortDirB7.ButtonDown()
        End If

        ' SmartPWM 기능
        ' 선택된 PWM Port
        m_iPWMChannel = If((radPWM1.Checked = True), 1, 2)
        If m_iPWMChannel = 1 Then
            SmartPWM1.StartPWM1()
        Else
            SmartPWM1.StartPWM2()
        End If
    End Sub

    ' Stop 버튼 클릭
    Private Sub btnStop_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnStop.Click
        ' SmartGPIO
        ' SmartGPIO 입력 신호 감지 중지
        GPIO_PortA.PortWatchStop()
        GPIO_PortB.PortWatchStop()
        GPIO_PortC.PortWatchStop()
        GPIO_PortD.PortWatchStop()
        GPIO_PortE.PortWatchStop()
        GPIO_PortF.PortWatchStop()

        ' SmartADC
        ' ADC값을 읽어오는 Timer를 중지
        SmartTimer1.Stop()

        ' SmartDAC
        ' SmartDAC를 사용하기 전 PortB6, B7이 INPUT이였으면 다시 이전상태로 설정
        If m_bPreB6Status = True Then
            GPIO_PortB.DirPin6 = SmartX.SmartGPIO.PINDIR.INPUT
            btnPortDirB6.ButtonUp()
        End If
        If m_bPreB7Status = True Then
            GPIO_PortB.DirPin7 = SmartX.SmartGPIO.PINDIR.INPUT
            btnPortDirB7.ButtonUp()
        End If

        ' SmartPWM
        If m_iPWMChannel = 1 Then
            SmartPWM1.StopPWM1()
        Else
            SmartPWM1.StopPWM2()
        End If
    End Sub

    ' Set Apply 버튼 클릭.
    Private Sub btnSetApply_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnSetApply.Click
        Dim iPortDirA As Integer
        Dim iPortDirB As Integer
        Dim iPortDirC As Integer
        Dim iPortDirD As Integer
        Dim iPortDirE As Integer
        Dim iPortDirF As Integer

        ' PORT-A를 선택한 경우
        ' Output : 1 or Input : 0
        iPortDirA = If((btnPortDirA0.ButtonStatus = SmartX.SmartButton.BUTSTATUS.DOWN), 1, 0)
        iPortDirA = iPortDirA Or (If((btnPortDirA1.ButtonStatus = SmartX.SmartButton.BUTSTATUS.DOWN), 1, 0)) << 1
        iPortDirA = iPortDirA Or (If((btnPortDirA2.ButtonStatus = SmartX.SmartButton.BUTSTATUS.DOWN), 1, 0)) << 2
        iPortDirA = iPortDirA Or (If((btnPortDirA3.ButtonStatus = SmartX.SmartButton.BUTSTATUS.DOWN), 1, 0)) << 3
        iPortDirA = iPortDirA Or (If((btnPortDirA4.ButtonStatus = SmartX.SmartButton.BUTSTATUS.DOWN), 1, 0)) << 4
        iPortDirA = iPortDirA Or (If((btnPortDirA5.ButtonStatus = SmartX.SmartButton.BUTSTATUS.DOWN), 1, 0)) << 5
        iPortDirA = iPortDirA Or (If((btnPortDirA6.ButtonStatus = SmartX.SmartButton.BUTSTATUS.DOWN), 1, 0)) << 6
        iPortDirA = iPortDirA Or (If((btnPortDirA7.ButtonStatus = SmartX.SmartButton.BUTSTATUS.DOWN), 1, 0)) << 7
        GPIO_PortA.PortDirs = iPortDirA
        iPortDirA = 0

        ' Port-B를 선택한 경우
        ' Output : 1 or Input : 0
        iPortDirB = If((btnPortDirB0.ButtonStatus = SmartX.SmartButton.BUTSTATUS.DOWN), 1, 0)
        iPortDirB = iPortDirB Or (If((btnPortDirB1.ButtonStatus = SmartX.SmartButton.BUTSTATUS.DOWN), 1, 0)) << 1
        iPortDirB = iPortDirB Or (If((btnPortDirB2.ButtonStatus = SmartX.SmartButton.BUTSTATUS.DOWN), 1, 0)) << 2
        iPortDirB = iPortDirB Or (If((btnPortDirB3.ButtonStatus = SmartX.SmartButton.BUTSTATUS.DOWN), 1, 0)) << 3
        iPortDirB = iPortDirB Or (If((btnPortDirB4.ButtonStatus = SmartX.SmartButton.BUTSTATUS.DOWN), 1, 0)) << 4
        iPortDirB = iPortDirB Or (If((btnPortDirB5.ButtonStatus = SmartX.SmartButton.BUTSTATUS.DOWN), 1, 0)) << 5
        iPortDirB = iPortDirB Or (If((btnPortDirB6.ButtonStatus = SmartX.SmartButton.BUTSTATUS.DOWN), 1, 0)) << 6
        iPortDirB = iPortDirB Or (If((btnPortDirB7.ButtonStatus = SmartX.SmartButton.BUTSTATUS.DOWN), 1, 0)) << 7
        GPIO_PortB.PortDirs = iPortDirB
        iPortDirB = 0

        ' Port-C를 선택한 경우
        ' Output : 1 or Input : 0
        iPortDirC = If((btnPortDirC0.ButtonStatus = SmartX.SmartButton.BUTSTATUS.DOWN), 1, 0)
        iPortDirC = iPortDirC Or (If((btnPortDirC1.ButtonStatus = SmartX.SmartButton.BUTSTATUS.DOWN), 1, 0)) << 1
        iPortDirC = iPortDirC Or (If((btnPortDirC2.ButtonStatus = SmartX.SmartButton.BUTSTATUS.DOWN), 1, 0)) << 2
        iPortDirC = iPortDirC Or (If((btnPortDirC3.ButtonStatus = SmartX.SmartButton.BUTSTATUS.DOWN), 1, 0)) << 3
        iPortDirC = iPortDirC Or (If((btnPortDirC4.ButtonStatus = SmartX.SmartButton.BUTSTATUS.DOWN), 1, 0)) << 4
        iPortDirC = iPortDirC Or (If((btnPortDirC5.ButtonStatus = SmartX.SmartButton.BUTSTATUS.DOWN), 1, 0)) << 5
        iPortDirC = iPortDirC Or (If((btnPortDirC6.ButtonStatus = SmartX.SmartButton.BUTSTATUS.DOWN), 1, 0)) << 6
        iPortDirC = iPortDirC Or (If((btnPortDirC7.ButtonStatus = SmartX.SmartButton.BUTSTATUS.DOWN), 1, 0)) << 7
        GPIO_PortC.PortDirs = iPortDirC
        iPortDirC = 0

        ' Port-D를 선택한 경우
        ' Output : 1 or Input : 0
        iPortDirD = If((btnPortDirD0.ButtonStatus = SmartX.SmartButton.BUTSTATUS.DOWN), 1, 0)
        iPortDirD = iPortDirD Or (If((btnPortDirD1.ButtonStatus = SmartX.SmartButton.BUTSTATUS.DOWN), 1, 0)) << 1
        iPortDirD = iPortDirD Or (If((btnPortDirD2.ButtonStatus = SmartX.SmartButton.BUTSTATUS.DOWN), 1, 0)) << 2
        iPortDirD = iPortDirD Or (If((btnPortDirD3.ButtonStatus = SmartX.SmartButton.BUTSTATUS.DOWN), 1, 0)) << 3
        iPortDirD = iPortDirD Or (If((btnPortDirD4.ButtonStatus = SmartX.SmartButton.BUTSTATUS.DOWN), 1, 0)) << 4
        iPortDirD = iPortDirD Or (If((btnPortDirD5.ButtonStatus = SmartX.SmartButton.BUTSTATUS.DOWN), 1, 0)) << 5
        iPortDirD = iPortDirD Or (If((btnPortDirD6.ButtonStatus = SmartX.SmartButton.BUTSTATUS.DOWN), 1, 0)) << 6
        iPortDirD = iPortDirD Or (If((btnPortDirD7.ButtonStatus = SmartX.SmartButton.BUTSTATUS.DOWN), 1, 0)) << 7
        GPIO_PortD.PortDirs = iPortDirD
        iPortDirD = 0

        ' Port-E를 선택한 경우
        ' Output : 1 or Input : 0
        iPortDirE = If((btnPortDirE0.ButtonStatus = SmartX.SmartButton.BUTSTATUS.DOWN), 1, 0)
        iPortDirE = iPortDirE Or (If((btnPortDirE1.ButtonStatus = SmartX.SmartButton.BUTSTATUS.DOWN), 1, 0)) << 1
        iPortDirE = iPortDirE Or (If((btnPortDirE2.ButtonStatus = SmartX.SmartButton.BUTSTATUS.DOWN), 1, 0)) << 2
        iPortDirE = iPortDirE Or (If((btnPortDirE3.ButtonStatus = SmartX.SmartButton.BUTSTATUS.DOWN), 1, 0)) << 3
        iPortDirE = iPortDirE Or (If((btnPortDirE4.ButtonStatus = SmartX.SmartButton.BUTSTATUS.DOWN), 1, 0)) << 4
        iPortDirE = iPortDirE Or (If((btnPortDirE5.ButtonStatus = SmartX.SmartButton.BUTSTATUS.DOWN), 1, 0)) << 5
        iPortDirE = iPortDirE Or (If((btnPortDirE6.ButtonStatus = SmartX.SmartButton.BUTSTATUS.DOWN), 1, 0)) << 6
        iPortDirE = iPortDirE Or (If((btnPortDirE7.ButtonStatus = SmartX.SmartButton.BUTSTATUS.DOWN), 1, 0)) << 7
        GPIO_PortE.PortDirs = iPortDirE
        iPortDirE = 0

        ' Port-F를 선택한 경우
        ' Output : 1 or Input : 0
        iPortDirF = If((btnPortDirF0.ButtonStatus = SmartX.SmartButton.BUTSTATUS.DOWN), 1, 0)
        iPortDirF = iPortDirF Or (If((btnPortDirF1.ButtonStatus = SmartX.SmartButton.BUTSTATUS.DOWN), 1, 0)) << 1
        iPortDirF = iPortDirF Or (If((btnPortDirF2.ButtonStatus = SmartX.SmartButton.BUTSTATUS.DOWN), 1, 0)) << 2
        iPortDirF = iPortDirF Or (If((btnPortDirF3.ButtonStatus = SmartX.SmartButton.BUTSTATUS.DOWN), 1, 0)) << 3
        iPortDirF = iPortDirF Or (If((btnPortDirF4.ButtonStatus = SmartX.SmartButton.BUTSTATUS.DOWN), 1, 0)) << 4
        iPortDirF = iPortDirF Or (If((btnPortDirF5.ButtonStatus = SmartX.SmartButton.BUTSTATUS.DOWN), 1, 0)) << 5
        iPortDirF = iPortDirF Or (If((btnPortDirF6.ButtonStatus = SmartX.SmartButton.BUTSTATUS.DOWN), 1, 0)) << 6
        iPortDirF = iPortDirF Or (If((btnPortDirF7.ButtonStatus = SmartX.SmartButton.BUTSTATUS.DOWN), 1, 0)) << 7
        GPIO_PortF.PortDirs = iPortDirF
        iPortDirF = 0
    End Sub

    ' Port를 Output으로 설정 후 버튼을 누르면 해당 포트의 출력 상태 변경(Low/High)
    Private Sub PortOutChange_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnOutStatusF7.Click, btnOutStatusF6.Click, btnOutStatusF5.Click, btnOutStatusF4.Click, btnOutStatusF3.Click, btnOutStatusF2.Click, btnOutStatusF1.Click, btnOutStatusF0.Click, btnOutStatusE7.Click, btnOutStatusE6.Click, btnOutStatusE5.Click, btnOutStatusE4.Click, btnOutStatusE3.Click, btnOutStatusE2.Click, btnOutStatusE1.Click, btnOutStatusE0.Click, btnOutStatusD7.Click, btnOutStatusD6.Click, btnOutStatusD5.Click, btnOutStatusD4.Click, btnOutStatusD3.Click, btnOutStatusD2.Click, btnOutStatusD1.Click, btnOutStatusD0.Click, btnOutStatusC7.Click, btnOutStatusC6.Click, btnOutStatusC5.Click, btnOutStatusC4.Click, btnOutStatusC3.Click, btnOutStatusC2.Click, btnOutStatusC1.Click, btnOutStatusC0.Click, btnOutStatusB7.Click, btnOutStatusB6.Click, btnOutStatusB5.Click, btnOutStatusB4.Click, btnOutStatusB3.Click, btnOutStatusB2.Click, btnOutStatusB1.Click, btnOutStatusB0.Click, btnOutStatusA7.Click, btnOutStatusA6.Click, btnOutStatusA5.Click, btnOutStatusA4.Click, btnOutStatusA3.Click, btnOutStatusA2.Click, btnOutStatusA1.Click, btnOutStatusA0.Click
        Dim iOutData As Integer = 0
        Dim iOutDatas As Integer = 0
        Dim btn As SmartX.SmartButton = CType(sender, SmartX.SmartButton)
        Dim strSelPortPin As String = btn.Name.Substring(13, 1)

        If btn.ButtonText = "Low" Then
            btn.ButtonText = "High"

            Select Case strSelPortPin
                Case "0"
                    iOutData = 1
                Case "1"
                    iOutData = 2
                Case "2"
                    iOutData = 4
                Case "3"
                    iOutData = 8
                Case "4"
                    iOutData = 16
                Case "5"
                    iOutData = 32
                Case "6"
                    iOutData = 64
                Case "7"
                    iOutData = 128
                Case Else
            End Select
        Else
            btn.ButtonText = "Low"

            Select Case strSelPortPin
                Case "0"
                    iOutData = &HFE
                Case "1"
                    iOutData = &HFD
                Case "2"
                    iOutData = &HFB
                Case "3"
                    iOutData = &HF7
                Case "4"
                    iOutData = &HEF
                Case "5"
                    iOutData = &HDF
                Case "6"
                    iOutData = &HBF
                Case "7"
                    iOutData = &H7F
            End Select
        End If

        Dim strSelPort As String = btn.Name.Substring(12, 1)

        Select Case strSelPort
            Case "A"

                If btn.ButtonText = "Low" Then
                    iOutDatas = GPIO_PortA.PortDatas And iOutData
                Else
                    iOutDatas = GPIO_PortA.PortDatas Or iOutData
                End If

                GPIO_PortA.PortDatas = iOutDatas
            Case "B"

                If btn.ButtonText = "Low" Then
                    iOutDatas = GPIO_PortB.PortDatas And iOutData
                Else
                    iOutDatas = GPIO_PortB.PortDatas Or iOutData
                End If

                GPIO_PortB.PortDatas = iOutDatas
            Case "C"

                If btn.ButtonText = "Low" Then
                    iOutDatas = GPIO_PortC.PortDatas And iOutData
                Else
                    iOutDatas = GPIO_PortC.PortDatas Or iOutData
                End If

                GPIO_PortC.PortDatas = iOutDatas
            Case "D"

                If btn.ButtonText = "Low" Then
                    iOutDatas = GPIO_PortD.PortDatas And iOutData
                Else
                    iOutDatas = GPIO_PortD.PortDatas Or iOutData
                End If

                GPIO_PortD.PortDatas = iOutDatas
            Case "E"

                If btn.ButtonText = "Low" Then
                    iOutDatas = GPIO_PortE.PortDatas And iOutData
                Else
                    iOutDatas = GPIO_PortE.PortDatas Or iOutData
                End If

                GPIO_PortE.PortDatas = iOutDatas
            Case "F"

                If btn.ButtonText = "Low" Then
                    iOutDatas = GPIO_PortF.PortDatas And iOutData
                Else
                    iOutDatas = GPIO_PortF.PortDatas Or iOutData
                End If

                GPIO_PortF.PortDatas = iOutDatas
        End Select
    End Sub

    ' PORT-A 감지 이벤트 처리 함수
    Private Sub GPIO_PortA_OnPortDatasChange(ByVal iPortDatas As System.Int32) Handles GPIO_PortA.OnPortDatasChange
        ' PORT-A의 각 핀 방향이 INPUT일 때 iPortDatas 값에 따른 Lamp On/Off
        If btnPortDirA0.ButtonStatus = SmartX.SmartButton.BUTSTATUS.UP Then
            pbLampA0.Image = If(((iPortDatas And 1) = 1), My.Resources.on_led, My.Resources.off_led)
        End If

        If btnPortDirA1.ButtonStatus = SmartX.SmartButton.BUTSTATUS.UP Then
            pbLampA1.Image = If((((iPortDatas And 2) >> 1) = 1), My.Resources.on_led, My.Resources.off_led)
        End If

        If btnPortDirA2.ButtonStatus = SmartX.SmartButton.BUTSTATUS.UP Then
            pbLampA2.Image = If((((iPortDatas And 4) >> 2) = 1), My.Resources.on_led, My.Resources.off_led)
        End If

        If btnPortDirA3.ButtonStatus = SmartX.SmartButton.BUTSTATUS.UP Then
            pbLampA3.Image = If((((iPortDatas And 8) >> 3) = 1), My.Resources.on_led, My.Resources.off_led)
        End If

        If btnPortDirA4.ButtonStatus = SmartX.SmartButton.BUTSTATUS.UP Then
            pbLampA4.Image = If((((iPortDatas And 16) >> 4) = 1), My.Resources.on_led, My.Resources.off_led)
        End If

        If btnPortDirA5.ButtonStatus = SmartX.SmartButton.BUTSTATUS.UP Then
            pbLampA5.Image = If((((iPortDatas And 32) >> 5) = 1), My.Resources.on_led, My.Resources.off_led)
        End If

        If btnPortDirA6.ButtonStatus = SmartX.SmartButton.BUTSTATUS.UP Then
            pbLampA6.Image = If((((iPortDatas And 64) >> 6) = 1), My.Resources.on_led, My.Resources.off_led)
        End If

        If btnPortDirA7.ButtonStatus = SmartX.SmartButton.BUTSTATUS.UP Then
            pbLampA7.Image = If((((iPortDatas And 128) >> 7) = 1), My.Resources.on_led, My.Resources.off_led)
        End If
    End Sub

    ' PORT-B 감지 이벤트 처리 함수
    Private Sub GPIO_PortB_OnPortDatasChange(ByVal iPortDatas As System.Int32) Handles GPIO_PortB.OnPortDatasChange
        ' PORT-B의 각 핀 방향이 INPUT일 때 iPortDatas 값에 따른 Lamp On/Off
        If btnPortDirB0.ButtonStatus = SmartX.SmartButton.BUTSTATUS.UP Then
            pbLampB0.Image = If(((iPortDatas And 1) = 1), My.Resources.on_led, My.Resources.off_led)
        End If

        If btnPortDirB1.ButtonStatus = SmartX.SmartButton.BUTSTATUS.UP Then
            pbLampB1.Image = If((((iPortDatas And 2) >> 1) = 1), My.Resources.on_led, My.Resources.off_led)
        End If

        If btnPortDirB2.ButtonStatus = SmartX.SmartButton.BUTSTATUS.UP Then
            pbLampB2.Image = If((((iPortDatas And 4) >> 2) = 1), My.Resources.on_led, My.Resources.off_led)
        End If

        If btnPortDirB3.ButtonStatus = SmartX.SmartButton.BUTSTATUS.UP Then
            pbLampB3.Image = If((((iPortDatas And 8) >> 3) = 1), My.Resources.on_led, My.Resources.off_led)
        End If

        If btnPortDirB4.ButtonStatus = SmartX.SmartButton.BUTSTATUS.UP Then
            pbLampB4.Image = If((((iPortDatas And 16) >> 4) = 1), My.Resources.on_led, My.Resources.off_led)
        End If

        If btnPortDirB5.ButtonStatus = SmartX.SmartButton.BUTSTATUS.UP Then
            pbLampB5.Image = If((((iPortDatas And 32) >> 5) = 1), My.Resources.on_led, My.Resources.off_led)
        End If

        If btnPortDirB6.ButtonStatus = SmartX.SmartButton.BUTSTATUS.UP Then
            pbLampB6.Image = If((((iPortDatas And 64) >> 6) = 1), My.Resources.on_led, My.Resources.off_led)
        End If

        If btnPortDirB7.ButtonStatus = SmartX.SmartButton.BUTSTATUS.UP Then
            pbLampB7.Image = If((((iPortDatas And 128) >> 7) = 1), My.Resources.on_led, My.Resources.off_led)
        End If
    End Sub

    ' PORT-C 감지 이벤트 처리 함수
    Private Sub GPIO_PortC_OnPortDatasChange(ByVal iPortDatas As System.Int32) Handles GPIO_PortC.OnPortDatasChange
        ' PORT-C의 각 핀 방향이 INPUT일 때 iPortDatas 값에 따른 Lamp On/Off
        If btnPortDirC0.ButtonStatus = SmartX.SmartButton.BUTSTATUS.UP Then
            pbLampC0.Image = If(((iPortDatas And 1) = 1), My.Resources.on_led, My.Resources.off_led)
        End If

        If btnPortDirC1.ButtonStatus = SmartX.SmartButton.BUTSTATUS.UP Then
            pbLampC1.Image = If((((iPortDatas And 2) >> 1) = 1), My.Resources.on_led, My.Resources.off_led)
        End If

        If btnPortDirC2.ButtonStatus = SmartX.SmartButton.BUTSTATUS.UP Then
            pbLampC2.Image = If((((iPortDatas And 4) >> 2) = 1), My.Resources.on_led, My.Resources.off_led)
        End If

        If btnPortDirC3.ButtonStatus = SmartX.SmartButton.BUTSTATUS.UP Then
            pbLampC3.Image = If((((iPortDatas And 8) >> 3) = 1), My.Resources.on_led, My.Resources.off_led)
        End If

        If btnPortDirC4.ButtonStatus = SmartX.SmartButton.BUTSTATUS.UP Then
            pbLampC4.Image = If((((iPortDatas And 16) >> 4) = 1), My.Resources.on_led, My.Resources.off_led)
        End If

        If btnPortDirC5.ButtonStatus = SmartX.SmartButton.BUTSTATUS.UP Then
            pbLampC5.Image = If((((iPortDatas And 32) >> 5) = 1), My.Resources.on_led, My.Resources.off_led)
        End If

        If btnPortDirC6.ButtonStatus = SmartX.SmartButton.BUTSTATUS.UP Then
            pbLampC6.Image = If((((iPortDatas And 64) >> 6) = 1), My.Resources.on_led, My.Resources.off_led)
        End If

        If btnPortDirC7.ButtonStatus = SmartX.SmartButton.BUTSTATUS.UP Then
            pbLampC7.Image = If((((iPortDatas And 128) >> 7) = 1), My.Resources.on_led, My.Resources.off_led)
        End If
    End Sub

    ' PORT-D 감지 이벤트 처리 함수
    Private Sub GPIO_PortD_OnPortDatasChange(ByVal iPortDatas As System.Int32) Handles GPIO_PortD.OnPortDatasChange
        ' PORT-D의 각 핀 방향이 INPUT일 때 iPortDatas 값에 따른 Lamp On/Off
        If btnPortDirD0.ButtonStatus = SmartX.SmartButton.BUTSTATUS.UP Then
            pbLampD0.Image = If(((iPortDatas And 1) = 1), My.Resources.on_led, My.Resources.off_led)
        End If

        If btnPortDirD1.ButtonStatus = SmartX.SmartButton.BUTSTATUS.UP Then
            pbLampD1.Image = If((((iPortDatas And 2) >> 1) = 1), My.Resources.on_led, My.Resources.off_led)
        End If

        If btnPortDirD2.ButtonStatus = SmartX.SmartButton.BUTSTATUS.UP Then
            pbLampD2.Image = If((((iPortDatas And 4) >> 2) = 1), My.Resources.on_led, My.Resources.off_led)
        End If

        If btnPortDirD3.ButtonStatus = SmartX.SmartButton.BUTSTATUS.UP Then
            pbLampD3.Image = If((((iPortDatas And 8) >> 3) = 1), My.Resources.on_led, My.Resources.off_led)
        End If

        If btnPortDirD4.ButtonStatus = SmartX.SmartButton.BUTSTATUS.UP Then
            pbLampD4.Image = If((((iPortDatas And 16) >> 4) = 1), My.Resources.on_led, My.Resources.off_led)
        End If

        If btnPortDirD5.ButtonStatus = SmartX.SmartButton.BUTSTATUS.UP Then
            pbLampD5.Image = If((((iPortDatas And 32) >> 5) = 1), My.Resources.on_led, My.Resources.off_led)
        End If

        If btnPortDirD6.ButtonStatus = SmartX.SmartButton.BUTSTATUS.UP Then
            pbLampD6.Image = If((((iPortDatas And 64) >> 6) = 1), My.Resources.on_led, My.Resources.off_led)
        End If

        If btnPortDirD7.ButtonStatus = SmartX.SmartButton.BUTSTATUS.UP Then
            pbLampD7.Image = If((((iPortDatas And 128) >> 7) = 1), My.Resources.on_led, My.Resources.off_led)
        End If
    End Sub

    ' PORT-E 감지 이벤트 처리 함수
    Private Sub GPIO_PortE_OnPortDatasChange(ByVal iPortDatas As System.Int32) Handles GPIO_PortE.OnPortDatasChange
        ' PORT-E의 각 핀 방향이 INPUT일 때 iPortDatas 값에 따른 Lamp On/Off
        If btnPortDirE0.ButtonStatus = SmartX.SmartButton.BUTSTATUS.UP Then
            pbLampE0.Image = If(((iPortDatas And 1) = 1), My.Resources.on_led, My.Resources.off_led)
        End If

        If btnPortDirE1.ButtonStatus = SmartX.SmartButton.BUTSTATUS.UP Then
            pbLampE1.Image = If((((iPortDatas And 2) >> 1) = 1), My.Resources.on_led, My.Resources.off_led)
        End If

        If btnPortDirE2.ButtonStatus = SmartX.SmartButton.BUTSTATUS.UP Then
            pbLampE2.Image = If((((iPortDatas And 4) >> 2) = 1), My.Resources.on_led, My.Resources.off_led)
        End If

        If btnPortDirE3.ButtonStatus = SmartX.SmartButton.BUTSTATUS.UP Then
            pbLampE3.Image = If((((iPortDatas And 8) >> 3) = 1), My.Resources.on_led, My.Resources.off_led)
        End If

        If btnPortDirE4.ButtonStatus = SmartX.SmartButton.BUTSTATUS.UP Then
            pbLampE4.Image = If((((iPortDatas And 16) >> 4) = 1), My.Resources.on_led, My.Resources.off_led)
        End If

        If btnPortDirE5.ButtonStatus = SmartX.SmartButton.BUTSTATUS.UP Then
            pbLampE5.Image = If((((iPortDatas And 32) >> 5) = 1), My.Resources.on_led, My.Resources.off_led)
        End If

        If btnPortDirE6.ButtonStatus = SmartX.SmartButton.BUTSTATUS.UP Then
            pbLampE6.Image = If((((iPortDatas And 64) >> 6) = 1), My.Resources.on_led, My.Resources.off_led)
        End If

        If btnPortDirE7.ButtonStatus = SmartX.SmartButton.BUTSTATUS.UP Then
            pbLampE7.Image = If((((iPortDatas And 128) >> 7) = 1), My.Resources.on_led, My.Resources.off_led)
        End If
    End Sub

    ' PORT-F 감지 이벤트 처리 함수
    Private Sub GPIO_PortF_OnPortDatasChange(ByVal iPortDatas As System.Int32) Handles GPIO_PortF.OnPortDatasChange
        ' PORT-E의 각 핀 방향이 INPUT일 때 iPortDatas 값에 따른 Lamp On/Off
        If btnPortDirF0.ButtonStatus = SmartX.SmartButton.BUTSTATUS.UP Then
            pbLampF0.Image = If(((iPortDatas And 1) = 1), My.Resources.on_led, My.Resources.off_led)
        End If

        If btnPortDirF1.ButtonStatus = SmartX.SmartButton.BUTSTATUS.UP Then
            pbLampF1.Image = If((((iPortDatas And 2) >> 1) = 1), My.Resources.on_led, My.Resources.off_led)
        End If

        If btnPortDirF2.ButtonStatus = SmartX.SmartButton.BUTSTATUS.UP Then
            pbLampF2.Image = If((((iPortDatas And 4) >> 2) = 1), My.Resources.on_led, My.Resources.off_led)
        End If

        If btnPortDirF3.ButtonStatus = SmartX.SmartButton.BUTSTATUS.UP Then
            pbLampF3.Image = If((((iPortDatas And 8) >> 3) = 1), My.Resources.on_led, My.Resources.off_led)
        End If

        If btnPortDirF4.ButtonStatus = SmartX.SmartButton.BUTSTATUS.UP Then
            pbLampF4.Image = If((((iPortDatas And 16) >> 4) = 1), My.Resources.on_led, My.Resources.off_led)
        End If

        If btnPortDirF5.ButtonStatus = SmartX.SmartButton.BUTSTATUS.UP Then
            pbLampF5.Image = If((((iPortDatas And 32) >> 5) = 1), My.Resources.on_led, My.Resources.off_led)
        End If

        If btnPortDirF6.ButtonStatus = SmartX.SmartButton.BUTSTATUS.UP Then
            pbLampF6.Image = If((((iPortDatas And 64) >> 6) = 1), My.Resources.on_led, My.Resources.off_led)
        End If

        If btnPortDirF7.ButtonStatus = SmartX.SmartButton.BUTSTATUS.UP Then
            pbLampF7.Image = If((((iPortDatas And 128) >> 7) = 1), My.Resources.on_led, My.Resources.off_led)
        End If
    End Sub

    Private Sub smartTimer1_Tick(ByVal sender As Object, ByVal e As EventArgs) Handles SmartTimer1.Tick
        ' 100ms 마다 Timer1의 tick 이벤트가 발생하여 ADCDisplay()함수를 실행합니다.
        ADCDisplay()
    End Sub

    ' ADC 입력값을 확인하는 메서드
    Private Sub ADCDisplay()
        Dim iChannel As Integer = 0
        Dim iADCData As Integer

        ' 현재 선택된 아날로그 입력 채널을 확인합니다.
        If radADC1.Checked = True Then
            iChannel = 0
        ElseIf radADC2.Checked = True Then
            iChannel = 1
        ElseIf radADC3.Checked = True Then
            iChannel = 2
        ElseIf radADC4.Checked = True Then
            iChannel = 3
        ElseIf radADC5.Checked = True Then
            iChannel = 4
        ElseIf radADC6.Checked = True Then
            iChannel = 5
        End If

        ' 선택된 채널의 A/D변환 값을 얻습니다.
        iADCData = SmartADC1.ReadData(iChannel)

        ' 레이블에 결과를 출력합니다.
        labADC.Text = iADCData.ToString()
    End Sub

    ' DAC 선택된 채널로 현재 설정된 값으로 출력 변경
    Private Sub DACValueChange(ByVal sender As Object, ByVal e As EventArgs) Handles udDAC.OnUpButtonClick, udDAC.OnDownButtonClick
        If m_iDACChannel = 1 Then
            SmartDAC1.DAC_Output(SmartX.SmartDAC.DACOUTCHANNEL.DAC_CHANNEL1, CInt(udDAC.Value))
        Else
            SmartDAC1.DAC_Output(SmartX.SmartDAC.DACOUTCHANNEL.DAC_CHANNEL2, CInt(udDAC.Value))
        End If
    End Sub

    ' PWM Duty값 증가 버튼
    Private Sub udPWM_OnUpButtonClick(ByVal sender As Object, ByVal e As EventArgs) Handles udPWM.OnUpButtonClick
        If m_iPWMChannel = 1 Then
            ' 현재 PWM1의 Duty값을 1씩 증가 처리 
            m_iPwm1Duty = If((m_iPwm1Duty < 100), System.Threading.Interlocked.Increment(m_iPwm1Duty), 100)
            SmartPWM1.DutyRate1 = m_iPwm1Duty
            udPWM.Value = m_iPwm1Duty
        Else
            ' 현재 PWM2의 Duty값을 1씩 증가 처리 
            m_iPwm2Duty = If((m_iPwm2Duty < 100), System.Threading.Interlocked.Increment(m_iPwm2Duty), 100)
            SmartPWM1.DutyRate2 = m_iPwm2Duty
            udPWM.Value = m_iPwm2Duty
        End If
    End Sub

    ' PWM Duty값 감소 버튼
    Private Sub udPWM_OnDownButtonClick(ByVal sender As Object, ByVal e As EventArgs) Handles udPWM.OnDownButtonClick
        If m_iPWMChannel = 1 Then
            ' 현재 PWM1의 Duty값을 1씩 감소 처리 
            m_iPwm1Duty = If((m_iPwm1Duty > 0), System.Threading.Interlocked.Decrement(m_iPwm1Duty), 0)
            SmartPWM1.DutyRate1 = m_iPwm1Duty
            udPWM.Value = m_iPwm1Duty
        Else
            ' 현재 PWM2의 Duty값을 1씩 감소 처리 
            m_iPwm2Duty = If((m_iPwm2Duty > 0), System.Threading.Interlocked.Decrement(m_iPwm2Duty), 0)
            SmartPWM1.DutyRate2 = m_iPwm2Duty
            udPWM.Value = m_iPwm2Duty
        End If
    End Sub

    ' FORM2 오픈. SmartInputCounter 테스트
    Private Sub btnShowForm2_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnShowForm2.Click
        ' FORM2를 호출하기전에 A~F포트 사용중지
        btnStop_Click(sender, e)

        ' FORM2 호출
        SmartForm1.Show(1)
    End Sub
End Class
