﻿Public Class Form2

    Private Sub btnSet_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnSet.Click
        GPIO_PortA.PortSelect = SmartX.SmartGPIO.PORTID.PORTA
        GPIO_PortB.PortSelect = SmartX.SmartGPIO.PORTID.PORTB

        ' **중요** InputCounter 블럭보다 반드시 먼저 설정해 주어야함
        ' A1이 Output인 경우
        If chkPortA1.Checked = True Then
            ' PORT A1을 출력으로 설정
            GPIO_PortA.DirPin0 = SmartX.SmartGPIO.PINDIR.OUTPUT
            GPIO_PortA.DirPin1 = SmartX.SmartGPIO.PINDIR.OUTPUT
            GPIO_PortA.DirPin2 = SmartX.SmartGPIO.PINDIR.OUTPUT
            GPIO_PortA.DirPin3 = SmartX.SmartGPIO.PINDIR.OUTPUT
        End If

        ' A2이 Output인 경우
        If chkPortA2.Checked = False Then
            ' PORT A2을 출력으로 설정
            GPIO_PortA.DirPin4 = SmartX.SmartGPIO.PINDIR.OUTPUT
            GPIO_PortA.DirPin5 = SmartX.SmartGPIO.PINDIR.OUTPUT
            GPIO_PortA.DirPin6 = SmartX.SmartGPIO.PINDIR.OUTPUT
            GPIO_PortA.DirPin7 = SmartX.SmartGPIO.PINDIR.OUTPUT
        End If

        ' B1이 Output인 경우
        If chkPortB1.Checked = False Then
            ' PORT A2을 출력으로 설정
            GPIO_PortB.DirPin0 = SmartX.SmartGPIO.PINDIR.OUTPUT
            GPIO_PortB.DirPin1 = SmartX.SmartGPIO.PINDIR.OUTPUT
            GPIO_PortB.DirPin2 = SmartX.SmartGPIO.PINDIR.OUTPUT
            GPIO_PortB.DirPin3 = SmartX.SmartGPIO.PINDIR.OUTPUT
        End If

        ' B2이 Output인 경우
        If chkPortB2.Checked = False Then
            ' PORT B2을 출력으로 설정
            GPIO_PortB.DirPin4 = SmartX.SmartGPIO.PINDIR.OUTPUT
            GPIO_PortB.DirPin5 = SmartX.SmartGPIO.PINDIR.OUTPUT
            GPIO_PortB.DirPin6 = SmartX.SmartGPIO.PINDIR.OUTPUT
            GPIO_PortB.DirPin7 = SmartX.SmartGPIO.PINDIR.OUTPUT
        End If

        If chkPortA1.Checked = True Then
            ' A1을 InputCounter로 사용
            SmartInputCounter1.InputCounterA1.PortMode = SmartX.SmartInputCounter.PORTMODES.Used

            If SmartInputCounter1.InputCounterA1.Initialize() = True Then
                ' 32Bit의 경우 최대 4,294,967,295를 표현 가능하며 64Bit의 경우 최대 1.8E308까지 표현 가능합니다.
                SmartInputCounter1.InputCounterA1.CounterDataWidth = SmartX.SmartInputCounter.DATAWIDTH._32BIT
            End If
        Else
            ' A1을 InputCounter로 사용안함
            SmartInputCounter1.InputCounterA1.PortMode = SmartX.SmartInputCounter.PORTMODES.NotUsed

            btnPortA1_Start.Enabled = False
            btnPortA1_Stop.Enabled = False
        End If

        If chkPortA2.Checked = True Then
            ' A2을 InputCounter로 사용
            SmartInputCounter1.InputCounterA2.PortMode = SmartX.SmartInputCounter.PORTMODES.Used

            If SmartInputCounter1.InputCounterA2.Initialize() = True Then
                ' 32Bit의 경우 최대 4,294,967,295를 표현 가능하며 64Bit의 경우 최대 1.8E308까지 표현 가능합니다.
                SmartInputCounter1.InputCounterA2.CounterDataWidth = SmartX.SmartInputCounter.DATAWIDTH._32BIT
            End If
        Else
            ' A2을 InputCounter로 사용안함
            SmartInputCounter1.InputCounterA2.PortMode = SmartX.SmartInputCounter.PORTMODES.NotUsed

            btnPortA2_Start.Enabled = False
            btnPortA2_Stop.Enabled = False
        End If

        ' B1을 InputCounter로 사용
        If chkPortB1.Checked = True Then
            SmartInputCounter1.InputCounterB1.PortMode = SmartX.SmartInputCounter.PORTMODES.Used

            If SmartInputCounter1.InputCounterB1.Initialize() = True Then
                ' 32Bit의 경우 최대 4,294,967,295를 표현 가능하며 64Bit의 경우 최대 1.8E308까지 표현 가능합니다.
                SmartInputCounter1.InputCounterB1.CounterDataWidth = SmartX.SmartInputCounter.DATAWIDTH._32BIT
            End If
        Else
            ' B1을 InputCounter로 사용안함
            SmartInputCounter1.InputCounterB1.PortMode = SmartX.SmartInputCounter.PORTMODES.NotUsed

            btnPortB1_Start.Enabled = False
            btnPortB1_Stop.Enabled = False
        End If

        ' B2을 InputCounter로 사용
        If chkPortB2.Checked = True Then
            SmartInputCounter1.InputCounterB2.PortMode = SmartX.SmartInputCounter.PORTMODES.Used

            If SmartInputCounter1.InputCounterB2.Initialize() = True Then
                ' 32Bit의 경우 최대 4,294,967,295를 표현 가능하며 64Bit의 경우 최대 1.8E308까지 표현 가능합니다.
                SmartInputCounter1.InputCounterB2.CounterDataWidth = SmartX.SmartInputCounter.DATAWIDTH._32BIT
            End If
        Else
            ' B2을 InputCounter로 사용안함
            SmartInputCounter1.InputCounterB2.PortMode = SmartX.SmartInputCounter.PORTMODES.NotUsed

            btnPortB2_Start.Enabled = False
            btnPortB2_Stop.Enabled = False
        End If

        ' SmartTimer는 Input Counter의 Count 값, Status 값, Output의 On/Off 출력
        If SmartTimer1.IsStart = False Then
            SmartTimer1.Interval = 10
            SmartTimer1.Start()
        End If
    End Sub

    ' A1 PIN1 Start/Stop
    Private Sub btnPortA1Button_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnPortA1_Stop.Click, btnPortA1_Start.Click
        If chkPortA1.Checked = True Then

            If sender Is btnPortA1_Start Then
                SmartInputCounter1.InputCounterA1.RunCounterPin1()
            Else
                SmartInputCounter1.InputCounterA1.PauseCounterPin1()
            End If
        End If
    End Sub

    ' A2 PIN1 Start/Stop
    Private Sub btnPortA2Button_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnPortA2_Stop.Click, btnPortA2_Start.Click
        If chkPortA2.Checked = True Then

            If sender Is btnPortA2_Start Then
                SmartInputCounter1.InputCounterA2.RunCounterPin1()
            Else
                SmartInputCounter1.InputCounterA2.PauseCounterPin1()
            End If
        End If
    End Sub

    ' B1 PIN1 Start/Stop
    Private Sub btnPortB1Button_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnPortB1_Stop.Click, btnPortB1_Start.Click
        If chkPortB1.Checked = True Then

            If sender Is btnPortB1_Start Then
                SmartInputCounter1.InputCounterB1.RunCounterPin1()
            Else
                SmartInputCounter1.InputCounterB1.PauseCounterPin1()
            End If
        End If
    End Sub

    ' B2 PIN1 Start/Stop
    Private Sub btnPortB2Button_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnPortB2_Stop.Click, btnPortB2_Start.Click
        If chkPortB2.Checked = True Then

            If sender Is btnPortB2_Start Then
                SmartInputCounter1.InputCounterB2.RunCounterPin1()
            Else
                SmartInputCounter1.InputCounterB2.PauseCounterPin1()
            End If
        End If
    End Sub

    ' Input Counter의 Count 값, Status 값, Output의 On/Off 출력
    Private Sub smartTimer1_Tick(ByVal sender As Object, ByVal e As EventArgs) Handles SmartTimer1.Tick
        ' A1의 PIN1 InputCounter 처리
        Try
            If chkPortA1.Checked = True Then
                labPortA1.Text = SmartInputCounter1.InputCounterA1.CounterPin1.ToString()
            End If

        Catch __unusedCheckSumErrorException1__ As SmartX.SmartInputCounter.CheckSumErrorException
            labPortA1.Text = "Data Error"
            labPortA1.Text = "0"
        End Try

        ' A2의 PIN1 InputCounter 처리
        Try
            If chkPortA2.Checked = True Then
                labPortA2.Text = SmartInputCounter1.InputCounterA2.CounterPin1.ToString()
            End If

        Catch __unusedCheckSumErrorException1__ As SmartX.SmartInputCounter.CheckSumErrorException
            labPortA2.Text = "Data Error"
            labPortA2.Text = "0"
        End Try

        ' B1의 PIN1 InputCounter 처리
        Try
            If chkPortB1.Checked = True Then
                labPortB1.Text = SmartInputCounter1.InputCounterB1.CounterPin1.ToString()
            End If

        Catch __unusedCheckSumErrorException1__ As SmartX.SmartInputCounter.CheckSumErrorException
            labPortB1.Text = "Data Error"
            labPortB1.Text = "0"
        End Try

        ' B2의 PIN1 InputCounter 처리
        Try
            If chkPortB2.Checked = True Then
                labPortB2.Text = SmartInputCounter1.InputCounterB2.CounterPin1.ToString()
            End If

        Catch __unusedCheckSumErrorException1__ As SmartX.SmartInputCounter.CheckSumErrorException
            labPortB2.Text = "Data Error"
            labPortB2.Text = "0"
        End Try
    End Sub

    ' Show Form1 버튼
    Private Sub btnShowForm1_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnShowForm1.Click
        ' SmartInputCounter Pause
        SmartInputCounter1.InputCounterA1.PauseCounterPin1()
        SmartInputCounter1.InputCounterA2.PauseCounterPin1()
        SmartInputCounter1.InputCounterB1.PauseCounterPin1()
        SmartInputCounter1.InputCounterB2.PauseCounterPin1()

        ' CheckBox 초기화
        chkPortA1.Checked = False
        chkPortA2.Checked = False
        chkPortB1.Checked = False
        chkPortB2.Checked = False

        SmartForm1.Show(0)
    End Sub
End Class